#include <vector>
#include <string>

using std::string;

#include "enum.h"

string single_pwd_enum_list::next() {
	// We're done.
	if(m_done) return "";

	// Form the result.
	string ret = "";
	for(auto i: m_counts) {
		ret += m_list[i];
	}

	// Increment.  If we make it through the loop, all are
	// consumed, and we clear m_list to flag done.
	for(auto i = m_counts.begin(); i < m_counts.end(); ++i) {
		if(++(*i) < m_list.size()) return ret;
		*i = 0;
	}
	m_done = true;
	return ret;
}

string single_pwd_enum_range::next() {
	// We're done.
	if(m_done) return "";

	// Current state is the return value.
	string ret = m_state;

	// Increment.  If we make it through the loop, all are
	// consumed, and we clear m_list to flag done.
	for(auto i = m_state.begin(); i < m_state.end(); ++i) {
		if(++(*i) <= m_high) return ret;
		*i = m_low;
	}
	m_done = true;
	return ret;
}

